From: =?utf-8?q?Guido_G=C3=BCnther?= <agx@sigxcpu.org>
Date: Tue, 15 Jun 2021 18:52:58 +0200
Subject: rfkill-hks: Mark irq and gpio as shared
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: 8bit

This allows several HKS to use the same GPIO (e.g. camera and mic)

Signed-off-by: Guido Günther <guido.gunther@puri.sm>
---
 net/rfkill/rfkill-hks.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

diff --git a/net/rfkill/rfkill-hks.c b/net/rfkill/rfkill-hks.c
index c56df9b..73062ac 100644
--- a/net/rfkill/rfkill-hks.c
+++ b/net/rfkill/rfkill-hks.c
@@ -131,8 +131,9 @@ static int rfkill_hks_setup_rfkill(struct platform_device *pdev,
 
 	sdata->hks = hks;
 	sdata->dev = dev;
-	sdata->gpiod = devm_fwnode_gpiod_get(dev, child,
-					     NULL, GPIOD_IN, desc);
+	sdata->gpiod = devm_fwnode_gpiod_get(dev, child, NULL,
+					     GPIOD_IN | GPIOD_FLAGS_BIT_NONEXCLUSIVE,
+					     desc);
 	if (IS_ERR(sdata->gpiod)) {
 		ret = PTR_ERR(sdata->gpiod);
 		if (ret != -EPROBE_DEFER)
@@ -176,7 +177,7 @@ static int rfkill_hks_setup_rfkill(struct platform_device *pdev,
 
 	ret = devm_request_any_context_irq(dev, sdata->irq,
 					   rfkill_hks_gpio_isr,
-					   IRQF_TRIGGER_RISING | IRQF_TRIGGER_FALLING,
+					   IRQF_TRIGGER_RISING | IRQF_TRIGGER_FALLING | IRQF_SHARED,
 					   desc, sdata);
 	if (ret < 0) {
 		dev_err(dev, "Unable to claim irq %d; error %d\n",
